// package death_match -- объект схватки
package death_match

import (
	"time"
	"wartank/pkg/arena"
	"wartank/pkg/types"
	"wartank/server/serv_bots/warbot/angar/battle/battle_register"
	"wartank/server/serv_bots/warbot/angar/battle/battle_wait"
	"wartank/server/serv_bots/warbot/angar/battle/battle_worker"
)

// Сражение -- объект схватки
type Схватка struct {
	types.ИАрена
	бот    types.ИБот
	клиент types.ИХттпВоркер

	регистрация *battle_register.СхваткаРегистрация // Регистратор на сражение
	ожидание    *battle_wait.СхваткаОжидание        // Ожидатель начала схватки
	действие    *battle_worker.СхваткаИсполнитель   // Исполнитель схватки

}

// НовСражение -- возвращает новый *Battle
func НовСхватка(бот types.ИБот) *Схватка {
	сам := &Схватка{
		бот:    бот,
		клиент: бот.Сеть().ВебВоркер(),
	}
	аренаКонфиг := arena.АренаКонфиг{
		Бот_:         бот,
		АренаИмя_:    "Группа схватки",
		СтрКонтроль_: `<span>до начала `,
		ФнПуск_:      сам.пуск,
	}
	сам.ИАрена = arena.НовАрена(аренаКонфиг)
	сам.регистрация = battle_register.НовСражениеРегистрация(бот)
	сам.ожидание = battle_wait.НовСражениеОжидание(бот)
	сам.действие = battle_worker.НовСражениеИсполнитель(бот)
	// сам.shotTimeFull.Set(8000) // 8000 msec
	return сам
}

func (сам *Схватка) Пуск() error {
	go сам.пуск()
	return nil
}

// запускает в работу сражение
func (сам *Схватка) пуск() {
	for {
		select {
		case <-сам.бот.Контекст().Done():
			return
		default:
			сам.регистрация.Зарегистрироваться()
			сам.ожидание.Ожидать()
			сам.действие.Пуск()
			time.Sleep(time.Second * 2) // Пауза между циклами, чтобы сервер не долбить запросами
		}
	}
}

// ЕслиНачало -- возвращает признак начала схватки (для браузера)
func (сам *Схватка) ЕслиНачало() types.ИСтатПарам {
	return сам.действие.Тревога()
}
